%ILSVRC Task 3
% this script demos the usage of evaluation routines
% the result file 'demo.val.pred.txt' on validation data is evaluated
% against the ground truth

meta_file = '../data/meta.mat';
pred_file='demo.val.pred.dat';
ground_truth_file='../data/ILSVRC2012_validation_ground_truth.txt';
fprintf('Pred file: %s\n', pred_file);
fprintf('ground_truth_file: %s\n\n', ground_truth_file);

load(meta_file);

average_precision = evalAP(pred_file, ground_truth_file, synsets);
fprintf('mAP: %f\n', mean(average_precision));

accuracy = evalAccuracy(pred_file, ground_truth_file, synsets);
fprintf('Accuracy: %f\n', accuracy);

% Perfect confidence matrix constructed using ground truth
pred_file='perfect.val.pred.dat';
ground_truth_file='../data/ILSVRC2012_validation_ground_truth.txt';
fprintf('\nPred file: %s\n', pred_file);
fprintf('ground_truth_file: %s\n\n', ground_truth_file);

average_precision = evalAP(pred_file, ground_truth_file, synsets);
fprintf('mAP: %f\n', mean(average_precision));

accuracy = evalAccuracy(pred_file, ground_truth_file, synsets);
fprintf('Accuracy: %f\n', accuracy);

% Code used to generate perfect confidence matrix:
% meta_file = '../data/meta.mat';
% ground_truth_file='../data/ILSVRC2012_validation_ground_truth.txt';
% load(meta_file);

% labels = load(ground_truth_file);
% remove_idx = labels<0;
% labels(remove_idx) = [];

% idx = zeros(max(labels), 1);
% idx([synsets.ILSVRC2012_ID]) = 1:length(synsets);

% labels = idx(labels);
% confidence = zeros(length(remove_idx), 120);
% idx2 = find(~remove_idx);  
% for i=1:length(idx2), confidence(idx2(i), labels(i)) = 1; end
% writeDat('perfect.val.pred.dat', confidence);
