function [ap] = evalAP(pred_file, ground_truth_file, synsets)
confidence = readDat(pred_file);
labels = load(ground_truth_file);

assert(size(confidence, 1)==length(labels));

remove_idx = labels<0;
confidence(remove_idx, :)=[];
labels(remove_idx) = [];

unique_cls = unique(labels);
ap = zeros(length(unique_cls), 1);

for i=1:length(unique_cls)
	cls_idx = (labels==unique_cls(i));
	gt = zeros(length(labels), 1);
	gt(cls_idx) = 1;
	gt(~cls_idx) = -1;

	[~,si]=sort(-confidence(:, i));
	tp=gt(si)>0;
	fp=gt(si)<0;

	fp=cumsum(fp);
	tp=cumsum(tp);
	rec=tp/sum(gt>0);
	prec=tp./(fp+tp);

	ap(i)=VOCap(rec,prec);
end
