function [accuracy] = evalAccuracy(pred_file, ground_truth_file, synsets)
confidence = readDat(pred_file);
labels = load(ground_truth_file);

assert(size(confidence, 1)==length(labels));

remove_idx = labels<0;
confidence(remove_idx, :)=[];
labels(remove_idx) = [];

idx = zeros(max(labels), 1);
idx([synsets.ILSVRC2012_ID]) = 1:length(synsets);

labels = idx(labels);
[~, pred_labels] = max(confidence, [], 2);
accuracy = sum(pred_labels==labels)/length(labels);
